Loading...
Searching...
No Matches
juce::StreamingSocket Class Referencefinal

## Detailed Description

A wrapper for a streaming (TCP) socket.

This allows low-level use of sockets; for an easier-to-use messaging layer on top of sockets, you could also try the InterprocessConnection class.

See also
  DatagramSocket, InterprocessConnection, InterprocessConnectionServer

The documentation for this class was generated from the following file:

- juce_core/network/juce_Socket.h

## Public Types

using | Options = SocketOptions

## Public Member Functions

| StreamingSocket ()
| Creates an uninitialised socket.
| StreamingSocket (const SocketOptions &optionsIn)
| Creates an uninitialised socket and allows specifying options related to the configuration of the underlying socket.
| ~StreamingSocket ()
| Destructor.
bool | bindToPort (int localPortNumber)
| Binds the socket to the specified local port.
bool | bindToPort (int localPortNumber, const String &localAddress)
| Binds the socket to the specified local port and local address.
int | getBoundPort () const noexcept
| Returns the local port number to which this socket is currently bound.
bool | connect (const String &remoteHostname, int remotePortNumber, int timeOutMillisecs=3000)
| Tries to connect the socket to hostname:port.
bool | isConnected () const noexcept
| True if the socket is currently connected.
void | close ()
| Closes the connection.
const String & | getHostName () const noexcept
| Returns the name of the currently connected host.
int | getPort () const noexcept
| Returns the port number that's currently open.
bool | isLocal () const noexcept
| True if the socket is connected to this machine rather than over the network.
int | getRawSocketHandle () const noexcept
| Returns the OS's socket handle that's currently open.
int | waitUntilReady (bool readyForReading, int timeoutMsecs)
| Waits until the socket is ready for reading or writing.
int | read (void *destBuffer, int maxBytesToRead, bool blockUntilSpecifiedAmountHasArrived)
| Reads bytes from the socket.
int | write (const void *sourceBuffer, int numBytesToWrite)
| Writes bytes to the socket from a buffer.
bool | createListener (int portNumber, const String &localHostName=String())
| Puts this socket into "listener" mode.
StreamingSocket * | waitForNextConnection () const
| When in "listener" mode, this waits for a connection and spawns it as a new socket.

## Member Typedef Documentation

## Options

using juce::StreamingSocket::Options = SocketOptions

## Constructors and Destructors

## StreamingSocket() [1/2]

juce::StreamingSocket::StreamingSocket | ( |  | ) |

Creates an uninitialised socket.

To connect it, use the connect() method, after which you can read() or write() to it.

To wait for other sockets to connect to this one, the createListener() method enters "listener" mode, and can be used to spawn new sockets for each connection that comes along.

Referenced by waitForNextConnection().

## StreamingSocket() [2/2]

juce::StreamingSocket::StreamingSocket | ( | const SocketOptions & | optionsIn | ) |

inline explicit

Creates an uninitialised socket and allows specifying options related to the configuration of the underlying socket.

To connect it, use the connect() method, after which you can read() or write() to it.

To wait for other sockets to connect to this one, the createListener() method enters "listener" mode, and can be used to spawn new sockets for each connection that comes along.

## ~StreamingSocket()

juce::StreamingSocket::~StreamingSocket | ( |  | ) |

Destructor.

## Member Functions

## bindToPort() [1/2]

bool juce::StreamingSocket::bindToPort | ( | int | localPortNumber | ) |

Binds the socket to the specified local port.

Returns
  true on success; false may indicate that another socket is already bound on the same port

## bindToPort() [2/2]

bool juce::StreamingSocket::bindToPort | ( | int | localPortNumber,
|  | const String & | localAddress )

Binds the socket to the specified local port and local address.

If localAddress is not an empty string then the socket will be bound to localAddress as well. This is useful if you would like to bind your socket to a specific network adapter. Note that localAddress must be an IP address assigned to one of your network address otherwise this function will fail.

Returns
  true on success; false may indicate that another socket is already bound on the same port

See also
  bindToPort (int localPortNumber), IPAddress::getAllAddresses

## getBoundPort()

int juce::StreamingSocket::getBoundPort | ( |  | ) | const

noexcept

Returns the local port number to which this socket is currently bound.

This is useful if you need to know to which port the OS has actually bound your socket when calling the constructor or bindToPort with zero as the localPortNumber argument.

Returns
  -1 if the function fails

## connect()

bool juce::StreamingSocket::connect | ( | const String & | remoteHostname,
|  | int | remotePortNumber,
|  | int | timeOutMillisecs = 3000 )

Tries to connect the socket to hostname:port.

If timeOutMillisecs is 0, then this method will block until the operating system rejects the connection (which could take a long time).

Returns
  true if it succeeds, false if otherwise

See also
  isConnected

References connect().

Referenced by connect().

## isConnected()

bool juce::StreamingSocket::isConnected | ( |  | ) | const

inline noexcept

True if the socket is currently connected.

References isConnected().

Referenced by isConnected().

## close()

void juce::StreamingSocket::close | ( |  | ) |

Closes the connection.

## getHostName()

const String & juce::StreamingSocket::getHostName | ( |  | ) | const

inline noexcept

Returns the name of the currently connected host.

## getPort()

int juce::StreamingSocket::getPort | ( |  | ) | const

inline noexcept

Returns the port number that's currently open.

## isLocal()

bool juce::StreamingSocket::isLocal | ( |  | ) | const

noexcept

True if the socket is connected to this machine rather than over the network.

## getRawSocketHandle()

int juce::StreamingSocket::getRawSocketHandle | ( |  | ) | const

inline noexcept

Returns the OS's socket handle that's currently open.

References getRawSocketHandle().

Referenced by getRawSocketHandle().

## waitUntilReady()

int juce::StreamingSocket::waitUntilReady | ( | bool | readyForReading,
|  | int | timeoutMsecs )

Waits until the socket is ready for reading or writing.

If readyForReading is true, it will wait until the socket is ready for reading; if false, it will wait until it's ready for writing.

If the timeout is < 0, it will wait forever, or else will give up after the specified time.

Returns
  1 if the socket is ready on return, 0 if it times-out before the socket becomes ready, or -1 if an error occurs

## read()

int juce::StreamingSocket::read | ( | void * | destBuffer,
|  | int | maxBytesToRead,
|  | bool | blockUntilSpecifiedAmountHasArrived )

Reads bytes from the socket.

If blockUntilSpecifiedAmountHasArrived is true, the method will block until maxBytesToRead bytes have been read, (or until an error occurs). If this flag is false, the method will return as much data as is currently available without blocking.

Returns
  the number of bytes read, or -1 if there was an error

See also
  waitUntilReady

## write()

int juce::StreamingSocket::write | ( | const void * | sourceBuffer,
|  | int | numBytesToWrite )

Writes bytes to the socket from a buffer.

Note that this method will block unless you have checked the socket is ready for writing before calling it (see the waitUntilReady() method).

Returns
  the number of bytes written, or -1 if there was an error

## createListener()

bool juce::StreamingSocket::createListener | ( | int | portNumber,
|  | const String & | localHostName = String() )

Puts this socket into "listener" mode.

When in this mode, your thread can call waitForNextConnection() repeatedly, which will spawn new sockets for each new connection, so that these can be handled in parallel by other threads.

Parameters

  portNumber | the port number to listen on
  localHostName | the interface address to listen on - pass an empty string to listen on all addresses

Returns
  true if it manages to open the socket successfully

See also
  waitForNextConnection

## waitForNextConnection()

StreamingSocket * juce::StreamingSocket::waitForNextConnection | ( |  | ) | const

When in "listener" mode, this waits for a connection and spawns it as a new socket.

The object that gets returned will be owned by the caller.

This method can only be called after using createListener().

See also
  createListener

References StreamingSocket().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited